/*
 * DiceGame.h
 */

#ifndef dicegame_DiceGame_h
#define dicegame_DiceGame_h

#include <vector>

class Dice;
class DiceGamePlayer;
class DiceGameListener;

class DiceGame
{
  public:
	enum Winner { COMPUTER = 1, PLAYER = 2 };

  public:
	DiceGame(DiceGameListener* listener);
	~DiceGame();

	int getRound()  { return m_round;  }
	int getWinner() { return m_winner; }
	DiceGamePlayer* getPlayer() { return m_player; }
	const std::vector<Dice*>& getDice() { return m_dice; }

	void run();

  protected:
	friend class DiceGameTest;
	int doRound();
	int inquireOddOrEven();
	int judge(int oddOrEven);

  private:
	int m_round;
	int m_winner;
	DiceGameListener* m_listener;
	DiceGamePlayer* m_player;
	std::vector<Dice*> m_dice;
};

#endif /* !dicegame_DiceGame_h */
