/*
 * DiceGameUI.cpp
 */

#include "DiceGameUI.h"
#include "Dice.h"
#include "DiceGamePlayer.h"
#include "DiceGame.h"
#include <stdlib.h>
#include <iostream>
using namespace std;

DiceGameUI::DiceGameUI()
{
	m_diceGame = new DiceGame(this);
}

DiceGameUI::~DiceGameUI()
{
	delete m_diceGame;
}

void DiceGameUI::show()
{
	cout << "<<< TCR Q[ >>>" << endl;
	do {
		cout << endl;
		m_diceGame->run();
		DiceGamePlayer* player = m_diceGame->getPlayer();
		cout << " " << player->getWins() << " "
			<< player->getLosses() << "słB" << endl;
	} while (inquireContinue());
}

void DiceGameUI::startRound()
{
	cout << "RRR..." << endl;
}

void DiceGameUI::endRound()
{
	const vector<Dice*>& dice = m_diceGame->getDice();
	for (vector<Dice*>::const_iterator p = dice.begin();
			p != dice.end(); ++p) {
		cout << '[' << (*p)->getValue() << ']';
	}
	cout << endl;
	if (m_diceGame->getWinner() == DiceGame::COMPUTER) {
		cout << "̏łB";
	} else {
		cout << "Ȃ̏łB";
	}
	DiceGamePlayer* player = m_diceGame->getPlayer();
	cout << "(" << player->getWins() << " "
			<< player->getLosses() << "s)" << endl << endl;
}

// MSVC++  istream& getline(istream&, string&) ɕs邽߁A
// istream& istream::getline(char_type*, streamsize n) gpB

int DiceGameUI::inquireOddOrEven()
{
	cout << "1: , 2: , 9: f --> " << flush;
	char buf[16];
	cin.getline(buf, sizeof(buf));
	return atoi(buf);
}

bool DiceGameUI::inquireContinue()
{
	char buf[16];
	for (;;) {
		cout << "Q[𑱂܂? (Y/N) --> " << flush;
		cin.getline(buf, sizeof(buf));
		if (buf[0] == 'Y' || buf[0] == 'y') return true;
		if (buf[0] == 'N' || buf[0] == 'n') return false;
	}
}
