/*
 * DiceTest.cpp
 */

#include "DiceTest.h"
#include "dicegame/Dice.h"
#include <cppunit/TestSuite.h>
#include <cppunit/TestCaller.h>
#include <cppunit/RepeatedTest.h>

USING_NAMESPACE_CPPUNIT

void DiceTest::testDice()
{
	Dice dice;
	TEST_ASSERT_EQUALS(0, dice.getValue());
	dice.shuffle();
	int value = dice.getValue();
	TEST_ASSERT(value != 0);
	TEST_ASSERT_EQUALS(value, dice.getValue());
}

void DiceTest::testLimits()
{
	Dice dice;
	dice.shuffle();
	int value = dice.getValue();
	TEST_ASSERT(1 <= value && value <= 6);
}

Test* DiceTest::suite()
{
	TestSuite* suite = new TestSuite("DiceTest");
	suite->addTest(new TEST_CALLER(DiceTest, testDice));
	suite->addTest(new RepeatedTest(new TEST_CALLER(DiceTest, testLimits), 12));
	return suite;
}
